% do the permutation, generate the encrypted image, and save the permutaed
% preidction error file
function [] = permutation(filename, width, height)
clear all;

if (exist('width') ~= 1)
    width         = 512; %% default profile
end
if (exist('height') ~= 1)
    height         = 512; %% default profile
end
fprintf('doing permutation...\n');
% load the pre err files
num_cls     = 16;
len_v       = zeros(1, num_cls);
pre_err     = cell(1, num_cls);
rpe_c       = cell(1, num_cls);
for i = 1:num_cls
   pre_err{i} =  load(strcat('.\result\pre_err',int2str(i), '.txt'));  
   len_v(i)     =  length(pre_err{i});
   idx = randperm(len_v(i));
   curr_pre_err =  pre_err{i};
   rpe_c{i} =curr_pre_err(idx);
   fid = fopen(strcat('.\result\rpe_c', int2str(i), '.txt'),'wt');
   fprintf(fid,'%d\n',rpe_c{i});
   fclose(fid);
end
len = sum(len_v);
encry = [rpe_c{1};rpe_c{2};rpe_c{3};rpe_c{4};rpe_c{5};rpe_c{6};rpe_c{7};rpe_c{8};rpe_c{9};rpe_c{10};rpe_c{11};rpe_c{12};rpe_c{13};rpe_c{14};rpe_c{15};rpe_c{16}];
encry = [rpe_c{10};rpe_c{9};rpe_c{5};rpe_c{2};rpe_c{3};rpe_c{6};rpe_c{12};rpe_c{16};rpe_c{8};rpe_c{4};rpe_c{15};rpe_c{1};rpe_c{7};rpe_c{11};rpe_c{13};rpe_c{14}];
idx = randperm(len);
encry = encry(idx);
encry=reshape(encry', width, height);
encry = uint8(encry);


if (exist('filename') == 1)
    subplot(1,2,2)
    imshow(encry)
    subplot(1,2,1) 
    imshow(filename)
else 
     imshow(encry)
end






